 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */



#ifndef _DSNX_LINKED_LIST_
#define _DSNX_LINKED_LIST_

#include <windows.h>

class CLinkedList {

public:
	CLinkedList(char *to_be_named,void *p = 0);
	virtual ~CLinkedList();

	bool Insert (CLinkedList **InsertMeInto,short Position =-1); /* default position is the end */
	bool Remove (CLinkedList **RemoveMeFrom);
	bool Rename(char *new_name);
	CLinkedList *Get	(short Offset);
	CLinkedList *Get	(char *match);

	unsigned short Count(void);
	char *name;
	void *pointer;

private:
	CLinkedList *pNext;
	CLinkedList *pLast;

};


#endif /* _DSNX_LINKED_LIST_  */