 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */


#ifndef _COMMANDS_HEADER_DSNX_
#define _COMMANDS_HEADER_DSNX_

#include "../include/shared.h"
#include "../include/DSNXSockets.h"
#include "../include/CLinkedLists.h"
#include "../include/mainbot.h"


class DSNXCommand : public CLinkedList {

public:
	DSNXCommand(char *command_id,USHORT required_lvl,DSNX_Command command);
	~DSNXCommand();

	DSNX_Command command;
	USHORT req_lvl;

};

extern CLinkedList *g_CommandList;

BOOL CleanAndRun(char *msg,char *from,char *mask,char *where,MainBot *bot,unsigned short auth_lvl);
void AddStaticCommands(void);
void AddCommandToList (char *name,DSNX_Command command,short auth_lvl);

#endif