 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */



#ifndef _DSNX_PLUGIN_MANAGER_H_
#define _DSNX_PLUGIN_MANAGER_H_

#include "../include/shared.h"
#include "../include/Clinkedlists.h"

class DSNXPlugin : public CLinkedList {

public:
	DSNXPlugin(char *named,pPluginAction ppRemove,HINSTANCE hlibrary);
	~DSNXPlugin();

	pPluginAction pRemove;
	CLinkedList *InstalledCommands;
	HINSTANCE library;
};

class PluginTracker : public CLinkedList {

public:
	PluginTracker(DSNXCommand *command);
	~PluginTracker();

	DSNXCommand *cmd;

};

extern CLinkedList *g_Plugins;

void UnloadPlugins(void);
bool UnloadPlugin(char *name);

bool IsValidSock(DSNXSocket *pointer);
bool AddPluginCmd(char *cid,DSNX_Command command,USHORT auth_lvl,char *plugin_name);
USHORT AddPlugins(const char *files);

#endif /* _DSNX_PLUGIN_MANAGER_H_ */
