 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */


#ifndef _AUTH_HEADER_DSNX_8329_
#define _AUTH_HEADER_DSNX_8329_

#include "../include/CLinkedLists.h"

extern char **g_cHostAllows;				 //For hostmask authentication
extern unsigned short g_iHostAllows;

#define MAX_AUTH_LVL			5
#define LGD_IN_AUTH_LVL			1
#define NO_AUTH					0
#define HOST_CHANGED_AUTH_LVL	-1

class IRCAuth : public CLinkedList {

public:
	IRCAuth(char *cNick,char*cMask,unsigned short uLevel);
	~IRCAuth();

	char *mask;
	unsigned short level;

};

BOOL IRCLogin(char* password,char* nick,char *mask,CLinkedList **auth);
BOOL IRCLogout(char *nick,CLinkedList ** auth);
short Validate(char *nick,char*mask,CLinkedList *auth);

#endif /*_AUTH_HEADER_DSNX_8329_*/
