 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	ServerList.cpp - Server lists :D

	Last revised : 31st March 2002

  */


#include "../include/serverlist.h"



ServerList::ServerList(char*name,USHORT number,char **to_add) : CLinkedList(name) {

	count = number;
	servers = new char*[number];


	while(number-- > 0) {
		servers[number] = new char[ strlen(to_add[number]) +1 ];
		strcpy(servers[number],to_add[number]);
	}


}

ServerList::~ServerList() {

	while (count -- > 0) {
		delete servers[count];
	}

	delete servers;


}
